import 'package:flutter/material.dart';
import 'package:provider/provider.dart';
import 'package:overlay_support/overlay_support.dart';

import 'package:momomotus/layout/game.dart';
import 'package:momomotus/layout/parameters.dart';
import 'package:momomotus/provider/data.dart';
import 'package:momomotus/utils/game_utils.dart';

class Home extends StatefulWidget {
  static const String id = 'home';

  const Home({super.key});

  @override
  HomeState createState() => HomeState();
}

class HomeState extends State<Home> {
  @override
  void initState() {
    super.initState();

    Data myProvider = Provider.of<Data>(context, listen: false);
    myProvider.initParametersValues();
  }

  @override
  Widget build(BuildContext context) {
    Data myProvider = Provider.of<Data>(context);

    List<Widget> menuActions = [];

    if (myProvider.gameIsRunning) {
      menuActions = [
        TextButton(
          child: const Image(
            image: AssetImage('assets/icons/button_back.png'),
            fit: BoxFit.fill,
          ),
          onPressed: () => toast('Long press to quit game...'),
          onLongPress: () => GameUtils.quitGame(myProvider),
        ),
      ];
    }

    return Scaffold(
      appBar: AppBar(
        actions: menuActions,
      ),
      body: SafeArea(
        child: Center(
          child: myProvider.gameIsRunning
              ? Game.buildGameWidget(myProvider)
              : Parameters.buildParametersSelector(myProvider),
        ),
      ),
    );
  }
}
